﻿using System;
using System.Data;
using System.Text;
using System.Linq;
using System.Drawing;
using System.Resources;
using System.ComponentModel;
using System.Collections.Generic;
using ZennoLab.CommandCenter;
using ZennoLab.InterfacesLibrary.ProjectModel;
using ZennoLab.InterfacesLibrary.ProjectModel.Enums;
using ZennoLab.Emulation;

namespace CCScript
{
	/// <summary>
	/// Класс выполнения группы действий
	/// </summary>
	internal class ActionGroup1
	{
		/// <summary>
		/// Метод выполнения группы действий
		/// </summary>
		/// <param name="instance">Объект инстанса выделеный для данного скрипта</param>
		/// <param name="project">Объект проекта выделеный для данного скрипта</param>
		/// <returns>Код выполнения группы действий</returns>
		public static int Execute(Instance instance, IZennoPosterProjectModel project)
		{
			project.Variables["start"].Value = new TimeSpan(DateTime.Now.Ticks).Ticks.ToString();
			
			// Очистка куков
			instance.ClearCookie();
			instance.ClearCache();

			// http://facebook.com/
			Tab tab = instance.ActiveTab;
			if ((tab.IsVoid) || (tab.IsNull)) return -1;
			if (tab.IsBusy) tab.WaitDownloading();
			tab.Navigate("http://facebook.com/", "");
			if (tab.IsBusy) tab.WaitDownloading();

			// {-Profile.Name-}
			HtmlElement he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("firstname");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("firstname");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 0);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.Name"
			he.SetValue(project.Profile.Name, instance.EmulationLevel, false);

			// {-Profile.Surname-}
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("lastname");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("lastname");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 1);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.Surname"
			he.SetValue(project.Profile.Surname, instance.EmulationLevel, false);

			// {-Profile.Email-}
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("reg_email__");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("reg_email__");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 2);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.Email"
			he.SetValue(project.Profile.Email, instance.EmulationLevel, false);

			// {-Profile.Email-}
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("reg_email_confirmation__");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("reg_email_confirmation__");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 3);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.Email"
			he.SetValue(project.Profile.Email, instance.EmulationLevel, false);

			// {-Profile.Password-}
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("reg_passwd__");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("reg_passwd__");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("input:password", "fulltag", "input:password", "text", 0);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.Password"
			he.SetValue(project.Profile.Password, instance.EmulationLevel, false);

			// {-Profile.BornMonth-...
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("birthday_month");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("birthday_month");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("select", "fulltag", "select", "text", 0);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.BornMonth.ToString()"
			he.SetValue(project.Profile.BornMonth.ToString(), instance.EmulationLevel, false);

			// {-Profile.BornDay-}
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("birthday_day");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("birthday_day");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("select", "fulltag", "select", "text", 1);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.BornDay.ToString()"
			he.SetValue(project.Profile.BornDay.ToString(), instance.EmulationLevel, false);

			// {-Profile.BornYear-}
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("birthday_year");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("birthday_year");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("select", "fulltag", "select", "text", 2);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "project.Profile.BornYear.ToString()"
			he.SetValue(project.Profile.BornYear.ToString(), instance.EmulationLevel, true);

			// Установка значения [1] элементу с тэгом [input:radio]
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByName("sex");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildById("u_0_1");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 1).FindChildByAttribute("input:radio", "fulltag", "input:radio", "text", 1);
			}
			if (he.IsVoid) return -1;

			// Задержка эмуляции
			instance.WaitFieldEmulationDelay();
			// Установить элементу значение "1"
			he.SetValue("1", instance.EmulationLevel, false);
			
			TimeSpan end = new TimeSpan(DateTime.Now.Ticks);
			var d = Convert.ToInt64(project.Variables["start"].Value);
			TimeSpan start = new TimeSpan(d);
			TimeSpan result = end - start;
			System.Windows.Forms.MessageBox.Show(result.TotalSeconds.ToString(), "Time");
			
			return 0;
		}
	}
}